<template>
  <v-row justify="center" no-gutters>
    <v-card style="width: 100%">
      <v-toolbar style="position:relative" color="white" elevation="0">
        <v-spacer />
        <v-toolbar-title class="mt-5">
          <span class="primary--text">
            <v-icon large color="primary" class="mr-2 pb-1">mdi-account-group</v-icon
            ><b>{{ title }}</b>
          </span>
        </v-toolbar-title>
        <v-spacer />
        <v-tooltip color="red" bottom>
          <template v-slot:activator="{ on }">
            <v-icon
              v-on="on"
              style="position:absolute; right: 15px"
              color="red"
              @click="handleClose"
              >mdi-close</v-icon
            >
          </template>
          <span><b>Fechar</b> janela</span>
        </v-tooltip>
      </v-toolbar>
      <!-- Read mode -->
      <div class="scrollForm">
        <FormatedMessage
          :itemToEdit="itemToEdit"
          :addEditMode="addEditMode"
          :buttonLabel="buttonLabel"
          @cancelReply="handleCancel"
          @sendedMsg="handleConfirm"
        />
      </div>
    </v-card>
  </v-row>
</template>

<script>
import FormatedMessage from '@/components/FormatedMessage.vue'
import CollaborativeWork from '../../services/collaborativeWork'
import collaborativeWork from '../../services/collaborativeWork'
export default {
  name: 'AddEdit',
  props: {
    itemToEdit: { type: Object, default: () => {} },
    itemToAnswer: { type: Object, default: () => {} },
    buttonLabel: { type: String, default: 'Salvar' },
    title: { type: String, default: 'Titulo ação' },
    addEditMode: { type: String, default: 'empty' },
  },
  components: {
    FormatedMessage,
  },
  data: () => ({
    newCollaborativeWork: {},
    newlyCreated: '',
  }),

  computed: {
    cleanAdvancedCollaborativeWork() {
      return this.$store.state.user.cleanAdvancedCollaborativeWork
    },
    checkDialogIsActive() {
      return this.$store.state.user.closeDialog
    },
  },
  watch: {
    checkDialogIsActive() {
      if (this.checkDialogIsActive) {
        this.handleClose()
        this.$store.commit('user/UPDATE_CLOSE_DIALOG', false)
      }
    },
  },
  created() {},
  methods: {
    // Front end métodos

    // fechar topo do dialog
    handleClose() {
      this.$emit('closeMessage')
      this.editMode = false
      this.$store.commit(
        'user/UPDATE_CLEAN_ADVANCED_COLLABORATIVEWORK',
        this.cleanAdvancedCollaborativeWork + 1
      )
    },

    //método ao cancelar do modo "add/editar"
    handleCancel() {
      this.editing = {}
      this.editMode = false
      this.$emit('closeMessage')
    },

    //adicionar/editar trabalho colaborativo

    async handleConfirm(item) {
      if (this.addEditMode == 'add') {
        if (item.title) this.newCollaborativeWork.name = item.title
        if (item.message) this.newCollaborativeWork.description = item.message
        if (item.initVisibilityDate)
          this.newCollaborativeWork.initVisibilityDate = item.initVisibilityDate
        if (item.endVisibilityDate)
          this.newCollaborativeWork.endVisibilityDate = item.endVisibilityDate
        // para o método updateAnswerInfos
        if (item.maxPerTeam) this.newCollaborativeWork.maxPerTeam = item.maxPerTeam
        if (item.initialDate) this.newCollaborativeWork.initialDate = item.initialDate
        if (item.endDate) this.newCollaborativeWork.endDate = item.endDate

        let ret = await this.addCollaborativeWork(this.newCollaborativeWork)

        this.$emit('addCollaborativeWorkDone', ret)
      }
      if (this.addEditMode == 'edit') {
        let id = this.itemToEdit.id
        if (item.title) this.newCollaborativeWork.name = item.title
        if (item.message) this.newCollaborativeWork.description = item.message
        if (item.initVisibilityDate)
          this.newCollaborativeWork.initVisibilityDate = item.initVisibilityDate
        if (item.endVisibilityDate)
          this.newCollaborativeWork.endVisibilityDate = item.endVisibilityDate
        if (item.public !== null) this.newCollaborativeWork.public = item.public
        // para o método updateAnswerInfos
        if (item.maxPerTeam) this.newCollaborativeWork.maxPerTeam = item.maxPerTeam
        if (item.initialDate) this.newCollaborativeWork.initialDate = item.initialDate
        if (item.endDate) this.newCollaborativeWork.endDate = item.endDate
        let data = { id: id, update: this.newCollaborativeWork }

        let ret = await this.editCollaborativeWork(data)

        this.$emit('addCollaborativeWorkDone', ret)
      }
      if (this.addEditMode == 'answer') {
        let id
        let ret
        if (this.itemToAnswer.answer.id) id = this.itemToAnswer.answer.id
        else id = this.itemToAnswer.collaborativeWorkAnswerId

        let answer = { title: '', comment: '' }

        if (item.title) answer.title = item.title
        if (item.message) answer.comment = item.message

        let data = { collaborativeWorkAnswerId: id, answer: answer }

        if (item.file) ret = await this.answerCollaborativeWork(data, item.file)
        else ret = await this.answerCollaborativeWork(data)

        this.$emit('addCollaborativeWorkDone', ret)
      }
    },

    /* backend métodos */

    async addCollaborativeWork(data) {
      let ret
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkCreate').id

        ret = await CollaborativeWork.createCollaborativeWork(routedEntity.id, actionId, data)

        if (ret.success) {
          this.newlyCreated = ret.data[0].id

          if (data.maxPerTeam || data.initialDate || data.endDate) {
            let updateInfo = {
              id: this.newlyCreated,
              update: {
                maxPerTeam: data.maxPerTeam,
                initialDate: data.initialDate,
                endDate: data.endDate,
              },
            }

            //executa método para atualizar outros dados
            await this.updateAnswerInfos(updateInfo)
          }
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return ret
    },
    async editCollaborativeWork(data) {
      let ret
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkUpdate').id

        ret = await CollaborativeWork.updateInfos(routedEntity.id, actionId, data)

        if (ret.success) {
          if (data.update.maxPerTeam || data.update.initialDate || data.update.endDate) {
            let updateInfo = {
              id: this.itemToEdit.id,
              update: {
                maxPerTeam: data.update.maxPerTeam,
                initialDate: data.update.initialDate,
                endDate: data.update.endDate,
              },
            }

            //executa método para atualizar outros dados
            await this.updateAnswerInfos(updateInfo)
          }
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return ret
    },
    async answerCollaborativeWork(data, file) {
      let ret
      try {
        this.$store.commit('user/UPDATE_LOADING', true)

        const routedEntity = await this.$getItem('routedEntity')
        const actionsMap = this.$store.state.user.mappedActions
        const actionId = actionsMap.get('collaborativeWorkAnswerCreate').id

        ret = await CollaborativeWork.createAnswersCollaborativeWork(
          routedEntity.id,
          actionId,
          data
        )
        if (ret.success && file) {
          let collaborativeWorkAnswerId = this.itemToAnswer.collaborativeWorkAnswerId
          let teamId = ret.data._id
          let teamAnswerId = ret.data.answer._id
          let fileName = file.name
          const formData = new FormData()
          formData.append('localFile', file)

          try {
            let ret2 = await CollaborativeWork.attachAnswerFile(
              routedEntity.id,
              actionId,
              collaborativeWorkAnswerId,
              teamId,
              teamAnswerId,
              fileName,
              formData
            )
          } catch (e) {
            console.log(e)
          }
        }
      } catch (e) {
        console.log(e)
      } finally {
        this.$store.commit('user/UPDATE_LOADING', false)
      }
      return ret
    },
    // alterar restrições para as respostas
    async updateAnswerInfos(data) {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('collaborativeWorkUpdate').id
      try {
        let ret = await CollaborativeWork.updateAnswerInfos(entityId, actionId, data)
      } catch (e) {
        console.log(e)
      }
    },
  },
}
</script>

<style></style>
